#include <stdio.h>
#include <bitset>

using namespace std;

#define maxn  88
#define maxnn maxn*maxn
#define maxmasti  8

int N, M;

/* intoarce numarul ecuatiei ce reprezinta pozitia (z, w) */
inline int m_ecuatie (int z, int w)
{ return z*N + w; }

/* intoarce numarul variabilei ce reprezinta plasarea mastii i in pozitia (z, w) */
inline int m_variabila (int i, int z, int w)
{ return i*(N-3)*(N-3) + z*(N - 3) + w; }

/*
a[0][0]*x0 + a[0][1]*x1 ... + a[0][Nvars - 1] * xNvars - 1 = a[0][Nvars]; celula 0
...
a[Nec - 1][0]*x0 + a[Nec - 1][1]*x1 ... + a[Nec - 1][Nvars - 1] * xNvars - 1 = a[Nec][Nvars]
*/

int Nec, Nvars;
bitset <maxnn*maxmasti> a[maxnn];

void init (void)
{
	int i, j, k, x, y;
	bool mat[4][4];
	scanf ("%d %d", &N, &M);
	Nec = N*N;
    Nvars = m_variabila (M, 0, 0);
	
	fprintf (stderr, "N=%d M=%d\n", N, M);
	
	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++) {
			scanf ("%d", &x);
			a[m_ecuatie (i, j)][Nvars] = x;
		}
	for (k = 0; k < M; k++) {
		for (i = 0; i < 4; i++)
			for (j = 0; j < 4; j++) {
				scanf ("%d", &x);
				mat[i][j] = x;
			}
		
		/* x, y - unde plasam masca; i, j - locatia afectata */
		for (x = 0; x <= N - 4; x++)
			for (y = 0; y <= N - 4; y++)
				for (i = 0; i < N; i++)
					for (j = 0; j < N; j++)
						if (i < x || j < y || x + 4 <= i || y + 4 <= j) 
							a[m_ecuatie(i, j)][m_variabila(k, x, y)] = true;
						else
							a[m_ecuatie(i, j)][m_variabila(k, x, y)] = mat[i - x][j - y];
	}
}

void dump(void)
{
	int i, j;
	for (i = 0; i < Nec; i++) {
		for (j = 0; j <= Nvars; j++)
			printf ("%d", a[i][j] ? 1 : 0);
		printf ("\n");
	}
	printf ("\n");
}

void solve (void)
{
	int i, nrprinc, j, k;
	bitset <maxnn*maxmasti> secundar, /* variabile secundare */
		tmp, nosol, sol;  /* no sol -> 00...0 = 1 */
	
	nosol[Nvars] = 1;
	
	// dump ();
	
	fprintf (stderr, "Nvars=%d\n", Nvars);
	fprintf (stderr, "Nec=%d\n", Nec);
	fprintf (stderr, "Nvars-Nec=%d\n", Nvars - Nec);
	
	for (i = 0, nrprinc = 0; i < Nvars; i++)	{
		for (j = nrprinc; j < Nec; j++)
			if (a[j][i])
				break;
		if (j < Nec && a[j][i]) {
			tmp = a[nrprinc];
			a[nrprinc] = a[j];
			a[j] = tmp;
			for (j = nrprinc + 1; j < Nec; j++)
				if (a[j][i])
					a[j] ^= a[nrprinc];
			nrprinc ++;
		} else {
			secundar[i] = true;
		}
	}
	
	for (i = 0; i < Nec; i++)
		if (a[i] == nosol) {
			printf ("0\n");
            fprintf (stderr, "imposibil\n");
			return;
		}
		
	// printf ("----\n");
	// dump ();
		
	for (i = 0; i < Nvars; i++)
		if (secundar[i]) /* punem valori aleatorii pt variabile secundare */
			sol [i] = false;
	
	for (i = 0; i < Nec; i++)
		for (j = 0; j < Nvars; j++)
			if (secundar[j] && a[i][j]) {
				a[i][j] = false;
				a[i][Nvars] = a[i][Nvars] ^ sol[j];
			}
		
	for (i = nrprinc - 1; i >= 0; i--) {
		for (j = 0; j < Nvars; j++)
			if (a[i][j])
				break;
		sol[j] = a[i][Nvars];
		for (k = 0; k <= i; k++)
			if (a[k][j]) {
				a[k][j] = 0;
				a[k][Nvars] = a[k][Nvars] ^ sol[j];
			}
	}
	
	printf ("2^%d\n", secundar.count());
	/*
	printf ("%d\n", (int) sol.count());
	{
		bool first = true;
		for (i = 0; i < Nvars; i++)
			if (sol[i]) {
				printf ("%s%d", first ? "" : " ", i + 1);
				first = false;
			}
	}
	*/
}

int main (void)
{
//	freopen ("foto.in", "rt", stdin);
//    freopen ("foto.out", "wt", stdout);
//    freopen ("foto.info", "wt", stderr);
	
	
	init ();
	solve ();
	
	return 0;
}

