/*
 *  Munte
 *  Solutia liniara, O(N)
 *  (thanks to Radu Berinde)
 */

#include <stdio.h>

#define SIZE	1000010
#define input	"munte.in"
#define output	"munte.out"

long N, V[SIZE];
long St[2 * SIZE], l, r;
long Best, Bpos;



void PushInStack(int pos)
{
    while (l <= r && V[St[r] % N] + St[r] < V[pos % N] + pos) 
		r--;
    St[++r] = pos;
}

void Solve()
{
    long i, j;

    l = 0, r = -1;
    for (i = 0; i < N; i++) 
		PushInStack(i);

    Best = V[St[l]] + St[l]; Bpos = 0;
    for (j = 1; j < N; j++)
    {
        if (St[l] == j - 1) l++;
        PushInStack(N + j - 1);
        if (Best > V[St[l] % N] + St[l] - j)
            Best = V[St[l] % N] + St[l] - j, Bpos = j;
    }
}

void Read_data()
{
    long i;

    FILE *f = fopen(input, "rt");
    fscanf(f, "%ld", &N);
    for (i = 0; i < N; i++) 
		fscanf(f, "%ld", V+i);
    fclose(f);
}

int main()
{	
    Read_data();
    Solve();

    fprintf(fopen(output, "wt"), "%ld %ld\n", Bpos + 1, Best);

    return 0;
}
