#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NMAX 260

#define NOT_COMPUTED 1
#define WINNING 2
#define LOSING 3
#define TO_BE_COMPUTED 4

int A[NMAX][NMAX], win[NMAX][NMAX][2];
int i, j, k, M, N;

void compute(int l, int c, int t)
{
	int i;

	win[l][c][t] = TO_BE_COMPUTED;

	if (t == 0)
	{ // Tom
		for (i = 1; i <= N; i++)
			if (i == l || A[l][i])
			{
				if (win[i][c][1] == NOT_COMPUTED)
					compute(i, c, 1);

				if (win[i][c][1] == WINNING)
				{
					win[l][c][0] = WINNING;
					break;
				}
			}

		if (win[l][c][0] == TO_BE_COMPUTED)
			win[l][c][0] = LOSING;
	}
	else
	{ // Jerry
		for (i = 1; i <= N; i++)
			if (i == c || A[c][i])
			{
				if (win[l][i][0] == NOT_COMPUTED)
					compute(l, i, 0);

				if (win[l][i][0] == LOSING || win[l][i][0] == TO_BE_COMPUTED)
				{
					win[l][c][1] = LOSING;
					break;
				}
			}

		if (win[l][c][1] == TO_BE_COMPUTED)
			win[l][c][1] = WINNING;
	}
}

int main()
{
	int T, ok;

	freopen("tj.in", "r", stdin);
	freopen("tj.out", "w", stdout);

	scanf("%d", &T);
	while (T--)
	{
		scanf("%d %d", &N, &M);
		fprintf(stderr, "* %d %d\n", N, M);

		memset(A, 0, sizeof(A));
		for (k = 0; k < M; k++)
		{
			scanf("%d %d", &i, &j);
			A[i][j] = A[j][i] = 1;
		}

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				for (k = 0; k < 2; k++)
					win[i][j][k] = NOT_COMPUTED;

		for (i = 1; i <= N; i++)
			win[i][i][0] = win[i][i][1] = WINNING;
		
		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				for (k = 0; k < 1; k++)
					if (win[i][j][k] == NOT_COMPUTED)
						compute(i, j, k);
		
		ok = 0;
		for (i = 1; i <= N && !ok; i++)
		{
			ok = 1;
			for (j = 1; j <= N && ok; j++)
				if (win[i][j][0] != WINNING)
					ok = 0;
		}

		if (ok)
			printf("DA\n");
		else
			printf("NU\n");
	
		fflush(stdout);

		fprintf(stderr, "%d\n", 20 - T);
	}

	return 0;
}