// O(N^3)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NMAX 260

int A[NMAX][NMAX], ntri[NMAX][NMAX], deg[NMAX], out[NMAX], p[NMAX];
int i, j, k, l, M, N, left;

void reduce(void)
{
	int ok;

	left = N;

	memset(out, 0, sizeof(out));

	ok = 1;

	for (i = 1; i <= N; i++)
		p[i] = i;

	while (left > 1 && ok)
	{
		ok = 0;
		for (i = 1; i <= left && !ok; i++)
				for (j = 1; j <= left && !ok; j++)
					if (i != j && A[p[i]][p[j]])
					{
						if (ntri[p[i]][p[j]] == deg[p[i]] - 1) // i este dominat de j
						{
							out[p[i]] = 1;

							// scade gradele celorlalte noduri (deoarece nodul i e scos din graf)
							for (k = 1; k <= left; k++)
								if (A[p[k]][p[i]])
									deg[p[k]]--;

							// face update la nr de triunghiuri
							for (k = 1; k <= left; k++)
								for (l = k + 1; l <= left; l++)
									if (A[p[k]][p[l]] && A[p[k]][p[i]] && A[p[l]][p[i]])
										ntri[p[k]][p[l]]--, ntri[p[l]][p[k]]--;

							ok = 1;
							left--;
							break;
						}
					}

		j = 0;
		for (i = 1; i <= N; i++)
			if (!out[i])
				p[++j] = i;
	}
}

int main()
{
	int T;

	freopen("tj.in", "r", stdin);
	freopen("tj.out", "w", stdout);

	scanf("%d", &T);
	while (T--)
	{
		scanf("%d %d", &N, &M);

		memset(A, 0, sizeof(A));
		memset(deg, 0, sizeof(deg));

		for (k = 0; k < M; k++)
		{
			scanf("%d %d", &i, &j);
			A[i][j] = A[j][i] = 1;
			deg[i]++;
			deg[j]++;
		}

		memset(ntri, 0, sizeof(ntri));
		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				if (i != j && A[i][j])
					for (k = 1; k <= N; k++)
						if (i != k && j != k && A[i][k] && A[j][k])
							ntri[i][j]++;
							
		reduce();

		if (left > 1)
			printf("NU\n");
		else
			printf("DA\n");

		fprintf(stderr, "%d\n", 20 - T);
	}

	return 0;
}