// O(N^4)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NMAX 260

int A[NMAX][NMAX], out[NMAX];
int i, j, k, M, N, left;

void reduce(void)
{
	int ok;

	left = N;

	memset(out, 0, sizeof(out));

	ok = 1;
	while (left > 1 && ok)
	{
		ok = 0;
		for (i = 1; i <= N && !ok; i++)
			if (!out[i])
				for (j = 1; j <= N && !ok; j++)
					if (i != j && !out[j] && A[i][j])
					{
						ok = 1;
						for (k = 1; k <= N && ok; k++)
							if (A[i][k] && !out[k] && i != k && j != k && !A[j][k])
								ok = 0;

						if (ok)
						{
							out[i] = 1;
							left--;

							/*
							for (k = 1; k <= N; k++)
								if (!out[k])
									;
							*/
						}
					}
	}
}

int main()
{
	int T;

	freopen("tj.in", "r", stdin);
	freopen("tj.out", "w", stdout);

	scanf("%d", &T);
	while (T--)
	{
		scanf("%d %d", &N, &M);

		memset(A, 0, sizeof(A));
		for (k = 0; k < M; k++)
		{
			scanf("%d %d", &i, &j);
			A[i][j] = A[j][i] = 1;
		}

		reduce();

		if (left > 1)
			printf("NU\n");
		else
			printf("DA\n");
	}

	return 0;
}